// SPDX-FileCopyrightText: Copyright 2024 shadPS4 Emulator Project
// SPDX-License-Identifier: GPL-2.0-or-later

#pragma once

#include <vector>
#include "common/types.h"

namespace Shader::Gcn {

struct VertexAttribute {
    u8 semantic;     ///< Semantic index of the attribute
    u8 dest_vgpr;    ///< Destination VGPR to load first component.
    u8 num_elements; ///< Number of components to load
    u8 sgpr_base;    ///< SGPR that contains the pointer to the list of vertex V#
    u8 dword_offset; ///< The dword offset of the V# that describes this attribute.
};

std::vector<VertexAttribute> ParseFetchShader(const u32* code);

} // namespace Shader::Gcn
